diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_whois.c PleXusIRCd-1.17a/modules/m_whois.c
--- ircd-hybrid-7.0/modules/m_whois.c	Sat Feb  8 19:02:28 2003
+++ PleXusIRCd-1.17a/modules/m_whois.c	Sun Nov 30 03:43:18 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_whois.c,v 1.87 2003/02/09 00:02:28 bill Exp $
+ *  $Id: m_whois.c,v 1.9 2003/11/30 00:02:28 Static Exp $
  */
 
 #include "stdinc.h"
@@ -76,7 +76,7 @@
   mod_del_cmd(&whois_msgtab);
 }
 
-const char *_version = "$Revision: 1.87 $";
+const char *_version = "$Revision: 1.9 $";
 #endif
 /*
 ** m_whois
@@ -382,15 +382,24 @@
   int tlen;
   int reply_to_send = NO;
   struct hook_mfunc_data hd;
+  char ubuf[BUFSIZE];
 #ifdef VCHANS
   struct Channel *bchan;
 #endif
   
   a2client_p = find_server(target_p->user->server);
           
-  sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+  //Hide the users real host
+  if (source_p->user == target_p->user || (IsOper(source_p) && !IsOper(target_p))) {
+    sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
 	 source_p->name, target_p->name,
 	 target_p->username, target_p->host, target_p->info);
+  } else {
+    sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+         source_p->name, target_p->name,
+         target_p->username, target_p->vhost, target_p->info);
+  }
+
   server_name = (char *)target_p->user->server;
 
   ircsprintf(buf, form_str(RPL_WHOISCHANNELS),
@@ -414,6 +423,7 @@
     }
 #endif
 
+  if (!IsOper(source_p) || !IsAdmin(source_p)) {
     if (ShowChannel(source_p, chptr))
     {
       if ((cur_len + strlen(chname) + 2) > (BUFSIZE - 4))
@@ -438,7 +448,28 @@
       reply_to_send = YES;
     }
   }
-
+  //Start of the test
+  else {
+      if ((cur_len + strlen(chname) + 2) > (BUFSIZE - 4))
+      {
+        sendto_one(source_p, "%s", buf);
+        cur_len = mlen;
+        t = buf + mlen;
+      }
+      if (!PubChannel(chptr))
+        {
+          ircsprintf(t, "~%s%s ", channel_chanop_or_voice(chptr, target_p), chname);
+        }
+      else {
+        ircsprintf(t, "%s%s ", channel_chanop_or_voice(chptr, target_p), chname);
+        }
+      tlen = strlen(t);
+      t += tlen;
+      cur_len += tlen;
+      reply_to_send = YES;
+    }
+  //END
+  }
   if (reply_to_send)
     sendto_one(source_p, "%s", buf);
           
@@ -452,13 +483,36 @@
                ServerInfo.network_name,
 	       ServerInfo.network_desc);
 
+  if (IsServices(target_p))
+        sendto_one(source_p, ":%s 313 %s %s :is an IRC Operator - Network Service", me.name,
+                source_p->name, target_p->name);
+  if (IsOper(target_p) && !IsServices(target_p)) {
+        sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
+                me.name, source_p->name, target_p->name);
+  }  
+      
+  if (IsReged(target_p)) sendto_one(source_p, form_str(RPL_WHOISREGNICK), me.name, source_p->name, target_p->name);
+  if ((IsOper(source_p) && !IsOper(target_p)) || (source_p == target_p))
+  {     
+    if (target_p->umodes & FLAGS_HIDDEN) {
+        sendto_one(source_p, form_str(RPL_WHOISVHOST),
+                   me.name, source_p->name, target_p->name, target_p->vhost);
+      }
+  }    
+  if (IsOper(source_p) || source_p == target_p) {  
+    send_umode(NULL, target_p, 0, ALL_UMODES, ubuf);   
+      if (!*ubuf)
+      {
+            ubuf[0] = '+';
+            ubuf[1] = '\0';
+      }
+      sendto_one(source_p, form_str(RPL_WHOISMODES),
+                   me.name, source_p->name, target_p->name, ubuf);
+  }
+
   if (target_p->user->away)
     sendto_one(source_p, form_str(RPL_AWAY), me.name,
 	       source_p->name, target_p->name, target_p->user->away);
-
-  if (IsOper(target_p))
-    sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
-	       me.name, source_p->name, target_p->name);
 
   if (MyConnect(target_p)) /* Can't do any of this if not local! db */
   {
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_whowas.c PleXusIRCd-1.17a/modules/m_whowas.c
--- ircd-hybrid-7.0/modules/m_whowas.c	Fri Jan 17 08:00:51 2003
+++ PleXusIRCd-1.17a/modules/m_whowas.c	Mon Jun 16 17:41:12 2003
@@ -151,7 +151,7 @@
           sendto_one(source_p, form_str(RPL_WHOWASUSER),
                      me.name, parv[0], temp->name,
                      temp->username,
-                     temp->hostname,
+                     IsOper(source_p) ? temp->hostname : temp->vhostname,
                      temp->realname);
 
           if (ConfigServerHide.hide_servers && !IsOper(source_p))
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/channel.c PleXusIRCd-1.17a/src/channel.c
--- ircd-hybrid-7.0/src/channel.c	Thu May 29 00:02:36 2003
+++ PleXusIRCd-1.17a/src/channel.c	Wed Aug 20 23:37:04 2003
@@ -63,7 +63,7 @@
 static void send_mode_list(struct Client *client_p, char *chname,
                            dlink_list *top, char flag, int clear);
 static int check_banned(struct Channel *chptr, struct Client *who,
-                                                char *s, char *s2);
+                                                char *s, char *s2, char *s3);
 
 static char buf[BUFSIZE];
 static char modebuf[MODEBUFLEN], parabuf[MODEBUFLEN];
@@ -1010,6 +1010,7 @@
 {
   char src_host[NICKLEN + USERLEN + HOSTLEN + 6];
   char src_iphost[NICKLEN + USERLEN + HOSTLEN + 6];
+  char src_vhost[NICKLEN + USERLEN + HOSTLEN + 6];
 
   if (!IsPerson(who))
     return (0);
@@ -1017,8 +1018,9 @@
   ircsprintf(src_host,"%s!%s@%s", who->name, who->username, who->host);
   ircsprintf(src_iphost,"%s!%s@%s", who->name, who->username,
 	     who->localClient->sockhost);
+  ircsprintf(src_vhost, "%s!%s@%s", who->name, who->username, who->vhost);
 
-  return (check_banned(chptr, who, src_host, src_iphost));
+  return (check_banned(chptr, who, src_host, src_iphost, src_vhost));
 }
 
 /*
@@ -1037,7 +1039,7 @@
  * +e code from orabidoo
  */
 static int
-check_banned(struct Channel *chptr, struct Client *who, char *s, char *s2)
+check_banned(struct Channel *chptr, struct Client *who, char *s, char *s2, char *s3)
 {
   dlink_node *ban;
   dlink_node *except;
@@ -1049,6 +1051,7 @@
     actualBan = ban->data;
     if (match(actualBan->banstr, s) || 
     	match(actualBan->banstr, s2) ||
+        match(actualBan->banstr, s3) ||
         match_cidr(actualBan->banstr, s2))
       break;
     else
@@ -1063,6 +1066,7 @@
 
       if (match(actualExcept->banstr, s) || 
           match(actualExcept->banstr, s2) ||
+	  match(actualExcept->banstr, s3) ||
           match_cidr(actualExcept->banstr, s2))
       {
         return CHFL_EXCEPTION;
@@ -1090,6 +1094,7 @@
   struct Ban *invex = NULL;
   char src_host[NICKLEN + USERLEN + HOSTLEN + 6];
   char src_iphost[NICKLEN + USERLEN + HOSTLEN + 6];
+  char src_vhost[NICKLEN + USERLEN + HOSTLEN +6];
 
   assert(source_p->localClient != NULL);
 
@@ -1097,10 +1102,15 @@
 	     "%s!%s@%s", source_p->name, source_p->username, source_p->host);
   ircsprintf(src_iphost,"%s!%s@%s", source_p->name, source_p->username,
 	     source_p->localClient->sockhost);
+  ircsprintf(src_vhost, "%s!%s@%s", source_p->name, source_p->username,
+             source_p->vhost);
 
-  if ((check_banned(chptr, source_p, src_host, src_iphost)) == CHFL_BAN)
+  if ((check_banned(chptr, source_p, src_host, src_iphost, src_vhost)) == CHFL_BAN)
     return (ERR_BANNEDFROMCHAN);
 
+  if ((chptr->mode.mode & MODE_REGONLY) && !IsReged(source_p))
+    return (ERR_REGNICKSONLY);
+
   if (chptr->mode.mode & MODE_INVITEONLY)
   {
     for (lp = source_p->user->invited.head; lp; lp = lp->next)
@@ -1114,7 +1124,7 @@
       DLINK_FOREACH(ptr, chptr->invexlist.head)
       {
         invex = ptr->data;
-        if (match(invex->banstr, src_host) || match(invex->banstr, src_iphost) ||
+        if (match(invex->banstr, src_host) || match(invex->banstr, src_iphost) || match(invex->banstr, src_vhost) ||
             match_cidr(invex->banstr, src_iphost))
           break;
       }
@@ -1128,6 +1138,9 @@
 
   if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
     return (ERR_CHANNELISFULL);
+  
+  if ((chptr->mode.mode & MODE_OPERONLY) && !IsOper(source_p))
+    return (ERR_NOPRIVILEGES);
 
   return 0;
 }
@@ -1240,7 +1253,7 @@
  * side effects - NONE
  */
 int
-can_send(struct Channel *chptr, struct Client *source_p)
+can_send(struct Channel *chptr, struct Client *source_p, char *msg)
 {
   if(MyClient(source_p) &&
      (find_channel_resv(chptr->chname) &&
@@ -1254,6 +1267,9 @@
   if (IsServer(source_p))
     return (CAN_SEND_OPV);
 
+  if ((chptr->mode.mode & MODE_NOCOLOUR) && msg_has_colours(msg))
+    return (CAN_SEND_NO);
+
   if (chptr->mode.mode & MODE_MODERATED)
     return (CAN_SEND_NO);
 
@@ -1429,5 +1445,27 @@
       free_topic(chptr);
     chptr->topic_time = 0;
   }
+}
+
+/* check to see if the message has any colour chars in it. */  
+int msg_has_colours(char *msg)
+{
+
+    char *c;
+    if (msg==NULL) return 0;
+    c=msg;
+
+    while(*c)
+    {
+        if(*c == '\003' || *c == '\033')
+            break;   
+        else
+            c++; 
+    }
+
+    if(*c) 
+        return 1;   
+
+    return 0;
 }
 
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/channel_mode.c PleXusIRCd-1.17a/src/channel_mode.c
--- ircd-hybrid-7.0/src/channel_mode.c	Sat Apr 19 22:33:41 2003
+++ PleXusIRCd-1.17a/src/channel_mode.c	Wed Aug 20 23:40:00 2003
@@ -254,9 +254,9 @@
     actualBan->who =
       (char *)MyMalloc(strlen(client_p->name) +
                        strlen(client_p->username) +
-                       strlen(client_p->host) + 3);
+                       strlen(client_p->vhost) + 3);
     ircsprintf(actualBan->who, "%s!%s@%s",
-               client_p->name, client_p->username, client_p->host);
+               client_p->name, client_p->username, client_p->vhost);
   }
   else
   {
@@ -495,6 +495,14 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_BW)
+    *mbuf++ = 'Z';
+  if (chptr->mode.mode & MODE_NOCOLOUR)
+    *mbuf++ = 'c';
+  if (chptr->mode.mode & MODE_REGONLY)
+    *mbuf++ = 'R';
+  if (chptr->mode.mode & MODE_OPERONLY)
+    *mbuf++ = 'O';
 #ifdef ANONOPS
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
@@ -1846,10 +1854,10 @@
   {chm_nosuch, NULL},                             /* L */
   {chm_nosuch, NULL},                             /* M */
   {chm_nosuch, NULL},                             /* N */
-  {chm_nosuch, NULL},                             /* O */
+  {chm_simple, (void *) MODE_OPERONLY},           /* O */
   {chm_nosuch, NULL},                             /* P */
   {chm_nosuch, NULL},                             /* Q */
-  {chm_nosuch, NULL},                             /* R */
+  {chm_simple, (void *) MODE_REGONLY},            /* R */
   {chm_nosuch, NULL},                             /* S */
   {chm_nosuch, NULL},                             /* T */
   {chm_nosuch, NULL},                             /* U */
@@ -1857,7 +1865,7 @@
   {chm_nosuch, NULL},                             /* W */
   {chm_nosuch, NULL},                             /* X */
   {chm_nosuch, NULL},                             /* Y */
-  {chm_nosuch, NULL},                             /* Z */
+  {chm_simple, (void *) MODE_BW},                 /* Z */
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},
@@ -1870,7 +1878,7 @@
   {chm_nosuch, NULL},				  /* a */
 #endif
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOUR},           /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
@@ -2098,7 +2106,7 @@
     mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
   else
     mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
-                     source_p->username, source_p->host, chname);
+                     source_p->username, source_p->vhost, chname);
 
   mc = 0;
   nc = 0;
@@ -2137,7 +2145,7 @@
         mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
       else
         mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
-                   source_p->username, source_p->host, chname);
+                   source_p->username, source_p->vhost, chname);
 
       pbl = 0;
       parabuf[0] = '\0';
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/client.c PleXusIRCd-1.17a/src/client.c
--- ircd-hybrid-7.0/src/client.c	Sun Mar  2 02:30:54 2003
+++ PleXusIRCd-1.17a/src/client.c	Wed Aug 20 19:54:16 2003
@@ -979,10 +979,10 @@
       ** that the client can show the "**signoff" message).
       ** (Note: The notice is to the local clients *only*)
       */
-      sendto_common_channels_local(source_p, 0,
+      sendto_common_channels_local(source_p,
                                    ":%s!%s@%s QUIT :%s",
 				   source_p->name, source_p->username,
-				   source_p->host, comment);
+				   source_p->vhost, comment);
 
       DLINK_FOREACH_SAFE(lp, next_lp, source_p->user->channel.head)
       {
@@ -1398,10 +1398,10 @@
     {
       if (client_p != NULL && source_p != client_p)
         sendto_one(source_p, "ERROR :Closing Link: %s %s (%s)",
-                   source_p->host, source_p->name, comment);
+                   source_p->vhost, source_p->name, comment);
       else
         sendto_one(source_p, "ERROR :Closing Link: %s (%s)",
-                   source_p->host, comment);
+                   source_p->vhost, comment);
     }
 
     /*
@@ -1695,10 +1695,10 @@
 			   source_p->name, nick, source_p->username,
 			   source_p->host);
 
-      sendto_common_channels_local(source_p, 1,
+      sendto_common_channels_local(source_p,
                                    ":%s!%s@%s NICK :%s",
 				   source_p->name, source_p->username,
-				   source_p->host, nick);
+				   source_p->vhost, nick);
       if (source_p->user)
 	{
 	  add_history(source_p, 1);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/cloak.c PleXusIRCd-1.17a/src/cloak.c
--- ircd-hybrid-7.0/src/cloak.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/src/cloak.c	Sun Nov 30 03:49:40 2003
@@ -0,0 +1,276 @@
+/*
+ *  PleXusIRCd: Based on Hybird7
+ *  cloak.c: Provides Hostname Cloaking
+ *
+ *  Copyright (C) 2000-2002 Edward Brocklesby, Hybrid Development Team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: cloak.c,v 1.8 2002/10/23 03:53:22 fishwaldo Exp $
+ */
+/*
+**
+** Originally rewritten from AustNet's VirtualWorld Code.
+** Virtual World written by Roger 'RogerY' Yerramsetti <rogery@austnet.org>
+**
+** Rewritten using the crc32 implementation by //ylo based on the original
+** implementation by Gary S. Brown
+**
+** hiddenhost implementation based on the code from UnrealIRCd by
+** RaYmAn, NiQuiL, narf, Griever (great thinking) eternal, bball, JK.@ roxnet.org
+**
+** Additional ideas and code by ShadowMaster, [-Th3Dud3-] (RageIRCd) and Solaris @ Demonkarma.net
+**
+*/
+
+
+
+#include "stdinc.h"
+
+#include "whowas.h"
+#include "client.h"
+#include "common.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "ircd_defs.h"
+#include "numeric.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "s_conf.h"
+#include "memory.h"
+#include "s_log.h"
+
+#define KEY 23857
+#define KEY2 38447
+#define KEY3 64709
+
+int str2arr (char **, char *, char *);
+unsigned long crc32 (const unsigned char *s, unsigned int len);
+
+
+ /* The implementation here was originally done by Gary S. Brown.  I have
+    borrowed the tables directly, and made some minor changes to the
+    crc32-function (including changing the interface). //ylo */
+
+  /* ============================================================= */
+  /*  COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or       */
+  /*  code or tables extracted from it, as desired without restriction.     */
+  /*                                                                        */
+  /*  First, the polynomial itself and its table of feedback terms.  The    */
+  /*  polynomial is                                                         */
+  /*  X^32+X^26+X^23+X^22+X^16+X^12+X^11+X^10+X^8+X^7+X^5+X^4+X^2+X^1+X^0   */
+  /*                                                                        */
+  /*  Note that we take it "backwards" and put the highest-order term in    */
+  /*  the lowest-order bit.  The X^32 term is "implied"; the LSB is the     */
+  /*  X^31 term, etc.  The X^0 term (usually shown as "+1") results in      */
+  /*  the MSB being 1.                                                      */
+  /*                                                                        */
+  /*  Note that the usual hardware shift register implementation, which     */
+  /*  is what we're using (we're merely optimizing it by doing eight-bit    */
+  /*  chunks at a time) shifts bits into the lowest-order term.  In our     */
+  /*  implementation, that means shifting towards the right.  Why do we     */
+  /*  do it this way?  Because the calculated CRC must be transmitted in    */
+  /*  order from highest-order term to lowest-order term.  UARTs transmit   */
+  /*  characters in order from LSB to MSB.  By storing the CRC this way,    */
+  /*  we hand it to the UART in the order low-byte to high-byte; the UART   */
+  /*  sends each low-bit to hight-bit; and the result is transmission bit   */
+  /*  by bit from highest- to lowest-order term without requiring any bit   */
+  /*  shuffling on our part.  Reception works similarly.                    */
+  /*                                                                        */
+  /*  The feedback terms table consists of 256, 32-bit entries.  Notes:     */
+  /*                                                                        */
+  /*      The table can be generated at runtime if desired; code to do so   */
+  /*      is shown later.  It might not be obvious, but the feedback        */
+  /*      terms simply represent the results of eight shift/xor opera-      */
+  /*      tions for all combinations of data and CRC register values.       */
+  /*                                                                        */
+  /*      The values must be right-shifted by eight bits by the "updcrc"    */
+  /*      logic; the shift must be unsigned (bring in zeroes).  On some     */
+  /*      hardware you could probably optimize the shift in assembler by    */
+  /*      using byte-swap instructions.                                     */
+  /*      polynomial $edb88320                                              */
+  /*                                                                        */
+  /*  --------------------------------------------------------------------  */
+
+static unsigned long crc32_tab[] = {
+  0x00000000L, 0x77073096L, 0xee0e612cL, 0x990951baL, 0x076dc419L,
+  0x706af48fL, 0xe963a535L, 0x9e6495a3L, 0x0edb8832L, 0x79dcb8a4L,
+  0xe0d5e91eL, 0x97d2d988L, 0x09b64c2bL, 0x7eb17cbdL, 0xe7b82d07L,
+  0x90bf1d91L, 0x1db71064L, 0x6ab020f2L, 0xf3b97148L, 0x84be41deL,
+  0x1adad47dL, 0x6ddde4ebL, 0xf4d4b551L, 0x83d385c7L, 0x136c9856L,
+  0x646ba8c0L, 0xfd62f97aL, 0x8a65c9ecL, 0x14015c4fL, 0x63066cd9L,
+  0xfa0f3d63L, 0x8d080df5L, 0x3b6e20c8L, 0x4c69105eL, 0xd56041e4L,
+  0xa2677172L, 0x3c03e4d1L, 0x4b04d447L, 0xd20d85fdL, 0xa50ab56bL,
+  0x35b5a8faL, 0x42b2986cL, 0xdbbbc9d6L, 0xacbcf940L, 0x32d86ce3L,
+  0x45df5c75L, 0xdcd60dcfL, 0xabd13d59L, 0x26d930acL, 0x51de003aL,
+  0xc8d75180L, 0xbfd06116L, 0x21b4f4b5L, 0x56b3c423L, 0xcfba9599L,
+  0xb8bda50fL, 0x2802b89eL, 0x5f058808L, 0xc60cd9b2L, 0xb10be924L,
+  0x2f6f7c87L, 0x58684c11L, 0xc1611dabL, 0xb6662d3dL, 0x76dc4190L,
+  0x01db7106L, 0x98d220bcL, 0xefd5102aL, 0x71b18589L, 0x06b6b51fL,
+  0x9fbfe4a5L, 0xe8b8d433L, 0x7807c9a2L, 0x0f00f934L, 0x9609a88eL,
+  0xe10e9818L, 0x7f6a0dbbL, 0x086d3d2dL, 0x91646c97L, 0xe6635c01L,
+  0x6b6b51f4L, 0x1c6c6162L, 0x856530d8L, 0xf262004eL, 0x6c0695edL,
+  0x1b01a57bL, 0x8208f4c1L, 0xf50fc457L, 0x65b0d9c6L, 0x12b7e950L,
+  0x8bbeb8eaL, 0xfcb9887cL, 0x62dd1ddfL, 0x15da2d49L, 0x8cd37cf3L,
+  0xfbd44c65L, 0x4db26158L, 0x3ab551ceL, 0xa3bc0074L, 0xd4bb30e2L,
+  0x4adfa541L, 0x3dd895d7L, 0xa4d1c46dL, 0xd3d6f4fbL, 0x4369e96aL,
+  0x346ed9fcL, 0xad678846L, 0xda60b8d0L, 0x44042d73L, 0x33031de5L,
+  0xaa0a4c5fL, 0xdd0d7cc9L, 0x5005713cL, 0x270241aaL, 0xbe0b1010L,
+  0xc90c2086L, 0x5768b525L, 0x206f85b3L, 0xb966d409L, 0xce61e49fL,
+  0x5edef90eL, 0x29d9c998L, 0xb0d09822L, 0xc7d7a8b4L, 0x59b33d17L,
+  0x2eb40d81L, 0xb7bd5c3bL, 0xc0ba6cadL, 0xedb88320L, 0x9abfb3b6L,
+  0x03b6e20cL, 0x74b1d29aL, 0xead54739L, 0x9dd277afL, 0x04db2615L,
+  0x73dc1683L, 0xe3630b12L, 0x94643b84L, 0x0d6d6a3eL, 0x7a6a5aa8L,
+  0xe40ecf0bL, 0x9309ff9dL, 0x0a00ae27L, 0x7d079eb1L, 0xf00f9344L,
+  0x8708a3d2L, 0x1e01f268L, 0x6906c2feL, 0xf762575dL, 0x806567cbL,
+  0x196c3671L, 0x6e6b06e7L, 0xfed41b76L, 0x89d32be0L, 0x10da7a5aL,
+  0x67dd4accL, 0xf9b9df6fL, 0x8ebeeff9L, 0x17b7be43L, 0x60b08ed5L,
+  0xd6d6a3e8L, 0xa1d1937eL, 0x38d8c2c4L, 0x4fdff252L, 0xd1bb67f1L,
+  0xa6bc5767L, 0x3fb506ddL, 0x48b2364bL, 0xd80d2bdaL, 0xaf0a1b4cL,
+  0x36034af6L, 0x41047a60L, 0xdf60efc3L, 0xa867df55L, 0x316e8eefL,
+  0x4669be79L, 0xcb61b38cL, 0xbc66831aL, 0x256fd2a0L, 0x5268e236L,
+  0xcc0c7795L, 0xbb0b4703L, 0x220216b9L, 0x5505262fL, 0xc5ba3bbeL,
+  0xb2bd0b28L, 0x2bb45a92L, 0x5cb36a04L, 0xc2d7ffa7L, 0xb5d0cf31L,
+  0x2cd99e8bL, 0x5bdeae1dL, 0x9b64c2b0L, 0xec63f226L, 0x756aa39cL,
+  0x026d930aL, 0x9c0906a9L, 0xeb0e363fL, 0x72076785L, 0x05005713L,
+  0x95bf4a82L, 0xe2b87a14L, 0x7bb12baeL, 0x0cb61b38L, 0x92d28e9bL,
+  0xe5d5be0dL, 0x7cdcefb7L, 0x0bdbdf21L, 0x86d3d2d4L, 0xf1d4e242L,
+  0x68ddb3f8L, 0x1fda836eL, 0x81be16cdL, 0xf6b9265bL, 0x6fb077e1L,
+  0x18b74777L, 0x88085ae6L, 0xff0f6a70L, 0x66063bcaL, 0x11010b5cL,
+  0x8f659effL, 0xf862ae69L, 0x616bffd3L, 0x166ccf45L, 0xa00ae278L,
+  0xd70dd2eeL, 0x4e048354L, 0x3903b3c2L, 0xa7672661L, 0xd06016f7L,
+  0x4969474dL, 0x3e6e77dbL, 0xaed16a4aL, 0xd9d65adcL, 0x40df0b66L,
+  0x37d83bf0L, 0xa9bcae53L, 0xdebb9ec5L, 0x47b2cf7fL, 0x30b5ffe9L,
+  0xbdbdf21cL, 0xcabac28aL, 0x53b39330L, 0x24b4a3a6L, 0xbad03605L,
+  0xcdd70693L, 0x54de5729L, 0x23d967bfL, 0xb3667a2eL, 0xc4614ab8L,
+  0x5d681b02L, 0x2a6f2b94L, 0xb40bbe37L, 0xc30c8ea1L, 0x5a05df1bL,
+  0x2d02ef8dL
+};
+
+/* Return a 32-bit CRC of the contents of the buffer. */
+
+unsigned long
+crc32 (const unsigned char *s, unsigned int len)
+{
+  unsigned int i;
+  unsigned long crc32val;
+
+  crc32val = 0;
+  for (i = 0; i < len; i++)
+    {
+      crc32val = crc32_tab[(crc32val ^ s[i]) & 0xff] ^ (crc32val >> 8);
+    }
+  return crc32val;
+}
+
+
+
+
+int
+str2arr (char **pparv, char *string, char *delim)
+{
+  char *tok;
+  int pparc = 0;
+
+  tok = (char *) strtok (string, delim);
+  while (tok != NULL)
+    {
+      pparv[pparc++] = tok;
+      tok = (char *) strtok (NULL, delim);
+    }
+
+  return pparc;
+}
+
+
+
+/* Regular user host */
+void
+make_virthost (char *curr, char *host, char *new)
+{
+  static char mask[HOSTLEN + 1];
+  char *parv[HOSTLEN + 1], *parv2[HOSTLEN + 1], s[HOSTLEN + 1],
+    s2[HOSTLEN + 2];
+  int parc = 0, parc2 = 0, len = 0;
+  unsigned long hash[8];
+  unsigned long masked[8];
+
+  /* Paranoia. curr & host are pointers */
+  strncpy (s2, curr, HOSTLEN);
+  strncpy (s, host, HOSTLEN);
+
+  parc = str2arr (parv, s, ".");
+  parc2 = str2arr (parv2, s2, ".");
+
+
+
+  /* crc32 and hashing using our 3 keys */
+  hash[0] = ((crc32 (parv[3], strlen (parv[3])) + KEY2) ^ KEY) ^ KEY3;
+  hash[1] = ((crc32 (parv[2], strlen (parv[2])) + KEY2) ^ KEY) ^ KEY3;
+
+
+  /* Why make life easy on crackers? Bitshifting */
+  hash[0] <<= 2;
+  hash[0] >>= 2;
+
+  hash[1] <<= 2;
+  hash[1] >>= 2;
+
+  /* Check if host could be IPv4 */
+  if (parc2 == 4 || parc2 < 2)
+    {
+      len = strlen (parv2[3]);
+      /* Check if its an IPv4 for sure */
+      if (strchr ("0123456789", parv2[3][len - 1]) || parc2 < 2)
+	{
+	  hash[2] = ((crc32 (parv[1], strlen (parv[1])) + KEY2) ^ KEY) ^ KEY3;
+	  hash[3] = ((crc32 (parv[0], strlen (parv[0])) + KEY2) ^ KEY) ^ KEY3;
+
+	  hash[2] <<= 2;
+	  hash[2] >>= 2;
+
+	  hash[3] <<= 2;
+	  hash[3] >>= 2;
+
+	  ircsprintf (mask, "%lx.%lx.%lx.%lx.IP",
+		      hash[0], hash[1], hash[2], hash[3]);
+	}
+      else
+	{
+	  ircsprintf (mask, "%s-%lx.%lx.%s.%s.%s",
+		      ServerInfo.network_name, hash[0], hash[1], parv2[parc2 - 3], parv2[parc2 - 2],
+		      parv2[parc2 - 1]);
+	}
+    }
+  else
+    {
+      if (parc2 >= 4)		/* There are isp's like *.isp.co.uk etc out there */
+	{
+	  ircsprintf (mask, "%s-%lx.%lx.%s.%s.%s",
+		      ServerInfo.network_name, hash[0], hash[1], parv2[parc2 - 3], parv2[parc2 - 2],
+		      parv2[parc2 - 1]);
+	}
+      else
+	{
+	  ircsprintf (mask, "%s-%lx.%lx.%s.%s",
+		      ServerInfo.network_name, hash[0], hash[1], parv2[parc2 - 2], parv2[parc2 - 1]);
+	}
+    }
+  strncpy (new, mask, HOSTLEN);
+  return;
+}
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/hold PleXusIRCd-1.17a/src/hold
--- ircd-hybrid-7.0/src/hold	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/src/hold	Fri Jun 20 08:08:42 2003
@@ -0,0 +1,8 @@
+s_conf.c:      if (kill_ptr->hold <= CurrentTime)
+s_conf.c:			       (kill_ptr->user) ? kill_ptr->user : "*",
+s_conf.c:			       (kill_ptr->host) ? kill_ptr->host : "*");
+s_conf.c:	  delete_one_address_conf(kill_ptr->host, kill_ptr);
+s_gline.c:    if( (kill_ptr->name && (!name || match(kill_ptr->name,name)))
+s_gline.c:	(kill_ptr->host && (!host || match(kill_ptr->host,host))))
+s_gline.c:    if(!irccmp(kill_ptr->host,host) && !irccmp(kill_ptr->name,user))
+s_gline.c:    if(kill_ptr->hold <= CurrentTime)
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/messages.tab PleXusIRCd-1.17a/src/messages.tab
--- ircd-hybrid-7.0/src/messages.tab	Tue May  6 01:32:17 2003
+++ PleXusIRCd-1.17a/src/messages.tab	Mon Aug 18 23:01:08 2003
@@ -289,8 +289,8 @@
 /* 263 RPL_LOAD2HI, */          
 ":%s 263 %s :Server load is temporarily too heavy. Please wait a while and try again.",
 /* 264 */       NULL,
-/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
-/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
+/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current server  users: %d  Max: %d",
+/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current network users: %d  Max: %d",
 /* 267 */       NULL,
 /* 268 */       NULL,
 /* 269 */       NULL,
@@ -331,10 +331,10 @@
 /* 304 RPL_TEXT, */      NULL,
 /* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
 /* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
-/* 307 */       NULL,
+/* 307 RPL_WHOISREGNICK, */     ":%s 307 %s %s is a Registered Nick",
 /* 308 */	NULL,
 /* 309 */       NULL,
-/* 310 */       NULL,
+/* 310 RPL_WHOISMODES */        ":%s 310 %s %s :is using Modes [%s]",
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
 /* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is an IRC Operator",
@@ -344,7 +344,7 @@
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
-/* 320 */      NULL,
+/* 320 RPL_WHOISVHOST */        ":%s 320 %s %s :Hostmask [%s]",
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
@@ -450,7 +450,7 @@
 /* 423 ERR_NOADMININFO, */
                 ":%s 423 %s %s :No administrative info available",
 /* 424 ERR_FILEERROR, */        ":%s 424 %s :File error doing %s on %s",
-/* 425 */       NULL,
+/* 425 ERROR_SERVICESDOWN, */       ":%s 425 %s :Services are currently down, join #help if you have any questions.",
 /* 426 */       NULL,
 /* 427 */       NULL,
 /* 428 */       NULL,
@@ -505,7 +505,7 @@
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
-/* 480 */       NULL,
+/* 480 ERR_REGNICKSONLY */      ":%s 480 %s %s :Cannot join channel (+R, Registered nicks only).",
 /* 481 ERR_NOPRIVILEGES, */
                 ":%s 481 %s :Permission Denied - You're not an IRC operator",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/s_bsd.c PleXusIRCd-1.17a/src/s_bsd.c
--- ircd-hybrid-7.0/src/s_bsd.c	Sat May 31 03:37:05 2003
+++ PleXusIRCd-1.17a/src/s_bsd.c	Wed Jul  2 18:04:18 2003
@@ -261,6 +261,8 @@
       ServerStats->is_sbr += client_p->localClient->receiveB;
       ServerStats->is_sks += client_p->localClient->sendK;
       ServerStats->is_skr += client_p->localClient->receiveK;
+      ServerStats->is_bwsavedB += client_p->localClient->bwsavedB;
+      ServerStats->is_bwsavedK += client_p->localClient->bwsavedK;
       ServerStats->is_sti += CurrentTime - client_p->firsttime;
       if (ServerStats->is_sbs > 2047)
         {
@@ -300,6 +302,8 @@
       ServerStats->is_cbr += client_p->localClient->receiveB;
       ServerStats->is_cks += client_p->localClient->sendK;
       ServerStats->is_ckr += client_p->localClient->receiveK;
+      ServerStats->is_bwsavedB += client_p->localClient->bwsavedB;
+      ServerStats->is_bwsavedK += client_p->localClient->bwsavedK;
       ServerStats->is_cti += CurrentTime - client_p->firsttime;
       if (ServerStats->is_cbs > 2047)
         {
@@ -311,6 +315,10 @@
           ServerStats->is_ckr += (ServerStats->is_cbr >> 10);
           ServerStats->is_cbr &= 0x3ff;
         }
+      if (ServerStats->is_bwsavedB > 2047) {
+         ServerStats->is_bwsavedK += (ServerStats->is_bwsavedB >> 10);
+         ServerStats->is_bwsavedB &= 0x3ff;
+      }
     }
   else
     ServerStats->is_ni++;
@@ -419,6 +427,7 @@
   } else
 #endif
     strlcat(new_client->host, new_client->localClient->sockhost,HOSTLEN+1);
+    strlcat(new_client->vhost, new_client->localClient->sockhost,HOSTLEN+1);
 
   new_client->localClient->fd        = fd;
   
